<?php
// @TODO this functionality needs to go into ContentCitationMap entity or somewhere
  /**
   * {@inheritdoc}
   */
  function submitForm(array &$form, FormStateInterface $form_state) {
    $type_defaults = $this->config->get('types') ?? [];
    $types = array_keys($form_state->getValue('types'), TRUE);
    $this->config->set('types', $types);

    $this::createFieldInstances($types);

    // Tell people they have to manually remove the Cite As field.
    if ($removed = array_diff($type_defaults, $types)) {
      $this->messenger()->addWarning($this->t('To remove citations from <code>@removed</code>, you will need to manually remove <code>field_cite_as</code>.', ['@removed' => implode(',', $removed)]));
    }

    $fields = array_map(function ($field_values) {
      return $field_values['entity'];
    }, $form_state->getValue('fields'));
    $this->config->set('fields', $fields);

    $this->config->save();

    $this->messenger()->addStatus($this->t('Your mapping has been saved.'));
  }

  public static function createFieldInstances($types) {
    if (!$types) {
      return;
    }
    $field_storage = FieldStorageConfig::loadByName('node', 'field_cite_as');
    // Ensure a cite as field exists for each specified content type.
    foreach ($types as $type) {
      $field = FieldConfig::loadByName('node', $type, 'field_cite_as');
      // If the field already exists, do not try to re-add or update it.
      if ($field) {
        continue;
      }
      $field = FieldConfig::create([
        'field_storage' => $field_storage,
        'bundle' => $type,
        'label' => 'Cite as',
      ]);
      $field->save();
      \Drupal::service('entity_display.repository')->getFormDisplay('node', $type)
        ->setComponent('field_cite_as', ['region' => 'hidden'])
        ->save();
      \Drupal::service('entity_display.repository')->getViewDisplay('node', $type)
        ->setComponent('field_cite_as', [
          'type' => 'entity_reference_entity_view',
          'label' => 'hidden',
          'settings' => [
            'view_mode' => 'cite_as',
          ],
          'weight' => 100,
          'region' => 'content',
        ])
        ->save();
    }
  }
